#Compile Exe "flatbut.exe"
#Register None
#Dim All

$Include "win32api.inc"
$Include "comdlg32.inc"
$Include "Commctrl.inc"

%ID_TOOLBAR   = 2033
%ID_TOOLBAR2  = 2034
%ID_TOOLBAR3  = 2035
%ID_TOOLBAR4  = 2036
%TB_LIST      = 0
%TB_STD_LIST  = 1
%TB_BM_ONLY   = 2
%TB_STD_BM    = 3
%IDC_BUTTON1  = 100
%IDC_BUTTON2  = 101
%IDC_BUTTON3  = 102
%IDC_BUTTON4  = 103
%ID_EDIT1     = 104
%ID_EDIT2     = 105
%ID_EDIT3     = 106
%ID_EDIT4     = 107

Function CreateFlatButton(ByVal hdlg&,ByVal TBID&,ByVal ctl&,ByVal resID&,txt$,ByVal x&,ByVal y&,ByVal wdth&,ByVal hgt&,ByVal flag&) As Long
  Local tb As TBBUTTON
  Local Tabm As TBADDBITMAP
  Tb.iBitmap = 0
  Tb.fsState = %TBSTATE_ENABLED
  Tb.fsStyle = %TBSTYLE_BUTTON
  Tb.dwData = 0
  Tb.iString = 0
  Tb.idCommand = ctl&
  Select Case flag&
    Case 0,1 'List Style, with text to the right
      Control Add "TOOLBARWINDOW32", hdlg&, TBID&, "",x&,y&,wdth&,hgt&+4, %WS_CHILD Or %WS_VISIBLE Or %CCS_NOPARENTALIGN Or %TBSTYLE_TOOLTIPS _
      Or %TBSTYLE_FLAT Or %CCS_NORESIZE Or %CCS_NODIVIDER Or %TBSTYLE_LIST
      If (flag&= 0) Then 'Uses DLL resource file for image
        Tabm.hInst = GetModuleHandle(ByVal %NULL)
        Tabm.nID = resID&
        Else ' Use standard system bitmaps
          Tabm.hInst = %HINST_COMMCTRL
          Tabm.nID = %IDB_STD_SMALL_COLOR
          Tb.iBitmap = resID&
      End If
      Control Send hdlg&, TBID&,%TB_SETBITMAPSIZE,0,MakLng(hgt&,hgt&)
      Control Send hdlg&, TBID&, %TB_ADDBITMAP,1, VarPtr(Tabm)
      Control Send hdlg&, TBID&, %TB_BUTTONSTRUCTSIZE, SizeOf(Tb), 0
      Control Send hdlg&, TBID&, %TB_ADDBUTTONS,1, VarPtr(Tb)
      txt$ = txt$ & $Nul & $Nul
      Control Send hdlg&, TBID&, %TB_ADDSTRING, 0, StrPtr(txt$)
    Case Else ' No text, just a bitmap
      Control Add "TOOLBARWINDOW32", hdlg&, TBID&, "",x&,y&,wdth&,hgt&, %WS_CHILD Or %WS_VISIBLE Or %CCS_NOPARENTALIGN Or %TBSTYLE_TOOLTIPS _
      Or %TBSTYLE_FLAT Or %CCS_NORESIZE Or %CCS_NODIVIDER
      If (flag&= 2) Then 'Uses DLL resource file for image
        Tabm.hInst = GetModuleHandle(ByVal %NULL)
        Tabm.nID = resID&
        Else ' Use standard system bitmaps
          Tabm.hInst = %HINST_COMMCTRL
          Tabm.nID = %IDB_STD_SMALL_COLOR
          Tb.iBitmap = resID&
      End If
      Control Send hdlg&, TBID&,%TB_SETBITMAPSIZE,0,MakLng(hgt&,hgt&)
      Control Send hdlg&, TBID&, %TB_ADDBITMAP,1, VarPtr(Tabm)
      Control Send hdlg&, TBID&, %TB_BUTTONSTRUCTSIZE, SizeOf(Tb), 0
      Control Send hdlg&, TBID&, %TB_ADDBUTTONS,1, VarPtr(Tb)
  End Select
  Control Send hdlg&, TBID&, %WM_SIZE, 0, 0
  Function= 1
End Function


CallBack Function maincb
  Static fname$,filter$,d&
  Select Case CbMsg
    Case %WM_NOTIFY
      Dim dsi As NMTTDISPINFO Ptr
      dsi = CbLParam
      If (@dsi.hdr.code= %TTN_GETDISPINFO) Then
        Select Case @dsi.hdr.idfrom
          Case %IDC_BUTTON1
            @dsi.sztext= " This is Button#1 "
          Case %IDC_BUTTON2
            @dsi.sztext= " This is Button#2 "
          Case %IDC_BUTTON3
            @dsi.sztext= " This is Button#3 "
          Case %IDC_BUTTON4
            @dsi.sztext= " This is Button#4 "
        End Select
      End If
    Case %WM_COMMAND
      Select Case CbCtl
        Case= %IDOK
          Dialog End CbHndl
        Case %IDC_BUTTON1 To %IDC_BUTTON4
          filter$ = "All Files (*.*)" & "|" & "*.*"
          d& = OPENFILEDIALOG(CbHndl,"Choose a File", fname$, CurDir$, filter$,"*.*",0)
          Select Case CbCtl
            Case %IDC_BUTTON1
              Control Set Text CbHndl,%ID_EDIT1,fname$
            Case %IDC_BUTTON2
              Control Set Text CbHndl,%ID_EDIT2,fname$
            Case %IDC_BUTTON3
              Control Set Text CbHndl,%ID_EDIT3,fname$
            Case %IDC_BUTTON4
              Control Set Text CbHndl,%ID_EDIT4,fname$
          End Select
      End Select
  End Select
End Function

Function PBMain
  Dim hdlg As Long
  Dialog New 0,"Emo Code",0,0,200,120,%DS_MODALFRAME Or %DS_3DLOOK Or %DS_CENTER Or %WS_POPUP Or %WS_CAPTION,, To hDlg
  Control Add Button,hDlg,%IDOK,"OK",144,100,50,14,,,
  Control Add TextBox,hdlg,%ID_EDIT1,"",5,15,170,12,,
  Call CREATEFLATBUTTON(hdlg&,%ID_TOOLBAR,%IDC_BUTTON1,%STD_FILEOPEN,"",180,15,16,16,%TB_STD_BM)
  Control Add TextBox,hdlg,%ID_EDIT2,"",5,35,170,12,,
  Call CREATEFLATBUTTON(hdlg&,%ID_TOOLBAR2,%IDC_BUTTON2,%STD_FILEOPEN,"",180,35,16,16,%TB_STD_BM)
  Control Add TextBox,hdlg,%ID_EDIT3,"",5,55,130,12,,
  Call CREATEFLATBUTTON(hdlg&,%ID_TOOLBAR3,%IDC_BUTTON3,%STD_FILESAVE,"Autosave ",140,55,56,16,%TB_STD_LIST)
  Control Add TextBox,hdlg,%ID_EDIT4,"",5,75,130,12,,
  Call CREATEFLATBUTTON(hdlg&,%ID_TOOLBAR4,%IDC_BUTTON4,%STD_PRINT,"Print Path ",140,75,56,16,%TB_STD_LIST)
  Dialog Show Modal hDlg Call MainCB
End Function
